<template>
<div>
  <ApiPicker />
  
  <h2>Simple Integration</h2>
  <h3>Install & Setup</h3>
  <row class="padding-between wrap-reverse">
    <cell class="grow docs">
      <p>
        Import BRD from a NPM-incldued library (if you're using
        webpack), or just reference the variable if you've included it
        as a script tag. Create a new instance with whatever options
        you desire, and wait until its ready.
      </p>
    </cell>
    <cell class="grow">
      <Prism class="wrap" :code="`\
// Import brd.js somehow (below for NPM-imported version, can also include via script tag)
import BRD from 'brd.js';
const BRD = await import('brd.js').then(b => b.default || b);

// create a reference
var brd = new BRD({ service: 'brd-js-tools', /* ...options */ });

// wait for connection to BRD to establish and the state to be fetched/dehydrated
this.ready = await brd.ready();
`"/>
    </cell>
  </row>

  
  <h3>Linking URL</h3>
  <row class="padding-between wrap-reverse">
    <cell class="grow docs">
      <p>
        A URL provides the information that the BRD app needs in order
        to communicate with the website.  Two varieties are common, a
        "deep link" and one designed for QR codes.  The only
        difference is that a "deep link" URL includes a return-to URL
        which is unnecessary when you're on two different devices,
        which is required to scan a QR code.
      </p>
      <h6>Working Example:</h6>
      <div v-if="qrUrl">
        <QrCode v-if="qrUrl" :value="qrUrl" />
      </div>
      <div>
        <a v-if="dlUrl" class="button" :href="dlUrl">Deep Link</a>
      </div>
    </cell>
    <cell class="grow">
      <Prism class="wrap">
// Show these to the user, depending on what kind of device they're on:
var qrLink = brd.qrLinkUrl();
var deepLink = brd.deepLinkUrl();

// qrLink = {{ qrUrl }}
// deepLink = {{ dlUrl }}
</Prism>
    </cell>
  </row>

  <h3>Linking Flow</h3>
  <row class="padding-between">
    <cell class="grow docs">
      <p>
        Linking a BRD wallet involves a simple handshake over the
        Encrypted Message Exchange (EME).  To facilitate this process,
        we have some helper methods which let you automate this
        process a bit.
      </p>
      <p>
        A common follow up to linking is to request the Ethereum
        address from the wallet, do so with
        the <code>brd.requestAddress('eth')</code> function.
      </p>
    </cell>
    <cell class="grow">
      <Prism class="wrap">
// wait for first link!
await brd.link();
var pubkey = brd.eme.linkedPubkey();

{{ !pubkey ? '// Waiting for link... (scan above)' : `// pubkey = ${pubkey.toString('hex')}` }}

// immediately request address:
var address = await brd.requestAddress('eth');

{{ !address ? '// Waiting for address... (scan above)' : `// address = ${address}` }}
</Prism>
    </cell>
  </row>

  <h3>Call & Payment Requests</h3>
  <row class="padding-between">
    <cell>
      <p>
        Once you're linked, whether or not you have requested an
        address, you may send payment and call requests.  All you need
        to do is send an scope (i.e. eth, btc...), address, and
        amount.  Call Requests allow you to specify an ABI for
        Ethereum or other network.  The "Amount" is always an integer
        in the minimum amount for the currency (wei for ETH, satoshis
        for btc, etc).  For example to send 1ETH would be 1E18.
      </p>
      <div>
        <stateful-button :disabled="!pubkey" :click="donate">Donate 0.01ETH to Ethereum Development Tip Jar</stateful-button>
      </div>
    </cell>
    <cell>
      <Prism class="wrap">
// Call request:
var callResponse = await brd.callRequest(scope,address,amount,abi,options);

// Payment request:
var paymentResponse = await brd.paymentRequest(
  'eth',
  '0xfB6916095ca1df60bB79Ce92cE3Ea74c37c5d359',
  (0.01 * 1E18).toFixed(0),
  { pushNotification: { message: 'Approve 0.01ETH Donation to Ethereum Foundation' } }
);
// paymentResponse: {{ result||'waiting...' }}

</Prism>
    </cell>
  </row>

  <h3>Reset / Cleanup</h3>
  <row class="padding-between">
    <cell>
      <p>
        You can reset the demo by clicking here:
      </p>
      <button class="button" @click="reset" >Reset</button>
    </cell>
    <cell>
      <Prism class="wrap">
// Clean up by calling destroy:
await brd.destroy();

// Reload to recreate:
document.location.reload();
      </Prism>
    </cell>
  </row>
      
  
</div>
</template>
<script>

export default {
  data() {
    return {
      qrUrl:null, dlUrl: null, address:null, pubkey: null, result: null
    };
  },
  async mounted() {
    var brd = this.$brd;
    
    this.ready = await brd.ready();


    this.inbox = brd.eme.messages;
    
    this.qrUrl = brd.eme.qrLinkUrl();
    this.dlUrl = brd.eme.deepLinkUrl();
    
    await brd.link();
      
    this.pubkey = brd.eme.linkedPubkey();
    this.address = await brd.requestAddress('eth');
  },
  methods: {
    async donate() {
      console.log("Sending payment request");
      this.result = await this.$brd.paymentRequest('eth','0xfB6916095ca1df60bB79Ce92cE3Ea74c37c5d359',(0.01 * 1E18).toFixed(0),{ pushNotification: { message: 'Approve 0.011ETH Donation to Ethereum Foundation' } });
      console.log("Done!");
    },
    async reset() {
      await this.$brd.destroy();
      document.location.reload();
    }
  }
}
  
</script>
<style lang="scss" scoped>

@import "~assets/mixins";

.ui-cell pre {
  margin: 0;
}

.docs {
  max-width: $grid*18;
}
  
  
</style>
